//########## Firework Cannon

//### Sounds

datablock AudioProfile(gc_FireworkCannonFireSound)
{
  filename = "./cannon.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_FireworkCannonParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 1 1 1";
  colors[1] = "1 1 1 0.25";
  colors[2] = "1 1 1 0";
  sizes[0] = 0.2;
  sizes[1] = 0.5;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_FireworkCannonEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 15;
  velocityVariance = 15;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 25;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_FireworkCannonParticle";
};

//### Item

datablock ItemData(gc_FireworkCannonItem)
{
  uiName = "Firework Cannon";
  iconName = "./icon_cannon";
  image = gc_FireworkCannonImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./cannon.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_FireworkCannonImage)
{
  shapeFile = "./cannon.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_FireworkCannonItem;
  ammo = "";
  projectile = "";
  casing = "";
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  minShotTime = 1000;

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateTransitionOnNoAmmo[1] = "NoAmmo";
  stateSequence[1] = "Ready";

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "Smoke";
  stateTimeoutValue[2] = 0.1;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateSequence[2] = "Fire";
  stateScript[2] = "onFire";
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_FireworkCannonEmitter;
  stateEmitterTime[2] = 0.1;
  stateEmitterNode[2] = muzzleNode;
  stateSound[2] = gc_FireworkCannonFireSound;
  stateSequence[2] = "Fire";

  stateName[3] = "Smoke";
  stateTimeoutValue[3] = 0.1;
  stateTransitionOnTimeout[3] = "CoolDown";

  stateName[5] = "CoolDown";
  stateTimeoutValue[5] = 0.5;
  stateTransitionOnTimeout[5] = "Reload";
  stateSequence[5] = "TrigDown";

  stateName[4] = "Reload";
  stateTransitionOnTriggerUp[4] = "Ready";
  stateSequence[4] = "TrigDown";

  stateName[6] = "NoAmmo";
  stateTransitionOnAmmo[6] = "Ready";
};

function gc_FireworkCannonImage::onFire(%this,%obj,%slot)
{
  %rnd = getRandom(0,9);
  if(%rnd == 0) %projectile = gc_fireworkSmallRedProjectile;
  else if(%rnd == 1) %projectile = gc_fireworkSmallOrangeProjectile;
  else if(%rnd == 2) %projectile = gc_fireworkSmallYellowProjectile;
  else if(%rnd == 3) %projectile = gc_fireworkSmallGreenProjectile;
  else if(%rnd == 4) %projectile = gc_fireworkSmallCyanProjectile;
  else if(%rnd == 5) %projectile = gc_fireworkSmallBlueProjectile;
  else if(%rnd == 6) %projectile = gc_fireworkSmallPurpleProjectile;
  else if(%rnd == 7) %projectile = gc_fireworkSmallWhiteProjectile;
  else if(%rnd == 8) %projectile = gc_fireworkSmallRainbow1Projectile;
  else
    %projectile = gc_fireworkSmallRainbow2Projectile;
  %spread = 0.003;
  %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %p = new Projectile()
  {
    dataBlock = %projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),50));
    initialPosition = %obj.getMuzzlePoint(0);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
}
