//########## Magic Rockets

//### Effects

datablock ParticleData(gc_fireworkMagicBlueGoldParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "base/lighting/flare";
  spinSpeed = 10;
  spinRandomMin = -10;
  spinRandomMax = 10;
  colors[0] = "0.2 0.6 1 1";
  colors[1] = "0.1 0.4 1 1";
  colors[2] = "1 0.6 0.3 1";
  colors[3] = "1 0 0 0";
  sizes[0] = 30;
  sizes[1] = 2;
  sizes[2] = 6;
  sizes[3] = 4;
  times[0] = 0;
  times[1] = 0.05;
  times[2] = 0.2;
  times[3] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkMagicBlueGoldEmitter)
{
  uiName = "";
  lifetimeMS = 100;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 35;
  velocityVariance = 15;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = false;
  particles = "gc_fireworkMagicBlueGoldParticle";
};

datablock ParticleEmitterData(gc_fireworkMagicBlueGoldSparkleEmitter)
{
  uiName = "";
  lifetimeMS = 100;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 35;
  velocityVariance = 25;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = true;
  particles = "gc_fireworkSparkleParticle";
};

datablock ExplosionData(gc_fireworkMagicBlueGoldExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = gc_fireworkMagicBlueGoldEmitter;
  emitter[1] = gc_fireworkMagicBlueGoldSparkleEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  damageRadius = 6;
  radiusDamage = 100;
  impulseRadius = 8;
  impulseForce = 25;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 10;
};

//### Projectile

datablock ProjectileData(gc_fireworkSmallBlueGoldProjectile)
{
  uiName = "Firework (M) Blue/Gold";
  projectileShapeName = "Add-ons/Projectile_Fireworks/firework.dts";
  directDamageType = $DamageType::gc_Firework;
  radiusDamageType = $DamageType::gc_Firework;
  particleEmitter = gc_fireworkTrailEmitter;
  explosion = gc_fireworkMagicBlueGoldExplosion;
  muzzleVelocity = 50;
  verInheritFactor = 1;
  lifetime = 3000;
  fadeDelay = 3000;
  armingDelay = 3000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.5;
  explodeOnDeath = true;
  explodeOnPlayerImpact = true;
  sound = gc_FuzeSound;
};

function gc_fireworkSmallBlueGoldProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}
