//########## Firework Projectiles

datablock AudioProfile(gc_FuzeSound)
{
  filename = "./fuze.wav";
  description = AudioClosestLooping3d;
  preload = true;
};

datablock AudioDescription(AudioVeryFar3d : AudioDefault3d)
{
  maxDistance = 1000;
  referenceDistance = 400;
  volume = 0.7;
};

datablock AudioProfile(gc_Firework1Sound)
{
  filename = "./firework1.wav";
  description = AudioVeryFar3d;
  preload = true;
};

datablock AudioProfile(gc_Firework2Sound)
{
  filename = "./firework2.wav";
  description = AudioVeryFar3d;
  preload = true;
};

datablock AudioProfile(gc_Firework3Sound)
{
  filename = "./firework3.wav";
  description = AudioVeryFar3d;
  preload = true;
};

datablock AudioProfile(gc_Firework4Sound)
{
  filename = "./firework4.wav";
  description = AudioVeryFar3d;
  preload = true;
};

datablock ParticleData(gc_FireworkTrailParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -150;
  spinRandomMax = 150;
  colors[0] = "1 1 0 0.4";
  colors[1] = "1 0.2 0 0.5";
  colors[2] = "0.2 0.2 0.2 0.3";
  colors[3] = "0 0 0 0";
  sizes[0] = 0.2;
  sizes[1] = 0.3;
  sizes[2] = 0.2;
  sizes[3] = 0.1;
  times[0] = 0;
  times[1] = 0.05;
  times[2] = 0.3;
  times[3] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_FireworkTrailEmitter)
{
  ejectionPeriodMS = 10;
  periodVarianceMS = 0;
  ejectionVelocity = 0.5;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_FireworkTrailParticle";
  uiName = "";
};

//### Damage Type

AddDamageType("gc_Firework",'<bitmap:Add-ons/Projectile_Fireworks/CI_firework> %1','%2 <bitmap:Add-ons/Projectile_Fireworks/CI_firework> %1',0.2,1);

exec("./smallrockets.cs");
exec("./bigrockets.cs");
exec("./sparklerockets.cs");
exec("./magicrockets.cs");
exec("./cannon.cs");
