//########## Sparkle Rockets

//### Sounds

//### Effects

datablock ParticleData(gc_fireworkSparkleParticle)
{
  dragCoefficient = 1;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "./sparks";
  spinSpeed = 0;
  colors[0] = "1 1 1 1";
  colors[1] = "1 0.6 0.4 1";
  colors[2] = "1 0 0 0";
  sizes[0] = 1;
  sizes[1] = 5;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_fireworkSparkleEmitter)
{
  uiName = "";
  lifetimeMS = 250;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 35;
  velocityVariance = 25;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = true;
  particles = "gc_fireworkSparkleParticle";
};

datablock ParticleData(gc_fireworkSparkleBlueParticle : gc_fireworkSparkleParticle)
{
  colors[0] = "1 1 1 1";
  colors[1] = "0.4 0.6 1 1";
  colors[2] = "0 0 1 0";
};

datablock ParticleEmitterData(gc_fireworkSparkleBlueEmitter : gc_fireworkSparkleEmitter)
{
  uiName = "";
  particles = "gc_fireworkSparkleBlueParticle";
};

datablock ExplosionData(gc_fireworkSparkleExplosion)
{
  lifeTimeMS = 250;
  emitter[0] = gc_fireworkSparkleEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  damageRadius = 3;
  radiusDamage = 100;
  impulseRadius = 4;
  impulseForce = 25;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 5;
};

datablock ExplosionData(gc_fireworkSparkleBlueExplosion : gc_fireworkSparkleExplosion) { emitter[0] = gc_fireworkSparkleBlueEmitter; };

//### Projectile

datablock ProjectileData(gc_fireworkSparkleProjectile)
{
  uiName = "Firework Sparkle Gold";
  projectileShapeName = "Add-ons/Projectile_Fireworks/firework.dts";
  directDamageType = $DamageType::gc_Firework;
  radiusDamageType = $DamageType::gc_Firework;
  particleEmitter = gc_FireworkTrailEmitter;
  explosion = gc_fireworkSparkleExplosion;
  muzzleVelocity = 50;
  verInheritFactor = 1;
  lifetime = 500;
  fadeDelay = 500;
  armingDelay = 500;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.5;
  explodeOnDeath = true;
  explodeOnPlayerImpact = true;
  sound = gc_FuzeSound;
};

datablock ProjectileData(gc_fireworkSparkleBlueProjectile : gc_fireworkSparkleProjectile)
{
  uiName = "Firework Sparkle Blue";
  explosion = gc_fireworkSparkleBlueExplosion;
};

function gc_fireworkSparkleProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}

function gc_fireworkSparkleBlueProjectile::onExplode(%this,%obj,%pos,%a)
{
  %rnd = getRandom(1,4);
  if(%rnd == 1) serverPlay3D(gc_Firework1Sound,%obj.getTransform());
  else if(%rnd == 2) serverPlay3D(gc_Firework2Sound,%obj.getTransform());
  else if(%rnd == 3) serverPlay3D(gc_Firework3Sound,%obj.getTransform());
  else
    serverPlay3D(gc_Firework4Sound,%obj.getTransform());
  parent::onExplode(%this,%obj,%pos,%a);
}
